<?php

namespace Insallah\Tournaments\View;

use Insallah\Tournaments\Config;
use Insallah\Tournaments\Model\GameConnector;
use Insallah\Tournaments\Model\Tournament;
use Insallah\Tournaments\Model\User;

class TList
{
    private string $str;

    public function __construct($user)
    {
        if (!Config::IS_ENABLED) {
            $this->str = '<div><strong style="color: crimson;">В данный момент турниры не проводятся!</strong></div>';
            return;
        }
        $tournamentstatus = new Tournament();
        $this->str = '<div>
            <strong style="color: crimson;">Внимание!</strong>
            <ul>
                <li>Присоединяясь к турниру покинуть заявку <u>невозможно</u>!</li>';
        if ((new GameConnector())->setUser($user->info['id'])->isEkrOverpriced()) {
            $this->str .= '<li>Стоимость предметов, одетых на вас не должна
                        превышать ' . Config::ekrOverpriceFormula($user->info['level']) . ' еврокредитов.
                    </li>';
        }
        if ($user->info['exp'] < Config::MIN_EXP) {
            $this->str .= '<li>У вас должно быть не менее ' . Config::MIN_EXP . ' опыта.</li>';
        }
        $this->str .= '<li>Турнир начнётся, когда в заявке
            наберётся ' . Config::START_TOURNAMENT . ' человек.</li>
        </ul>
        </div>';
        $this->str .= $tournamentstatus->getList();
        if (!User::getTournamentIdByUserId($user->info['id']) || !$tournamentstatus->isStarted($user->info['level'])) {
            $this->str .= '<form method="post">
            <input type="submit" name="tournament_start" value="Принять участие в турнире">
            <input type="hidden" name="key" value="' . $_SESSION['bypass'] . '">
        </form>';
        } else {
            $this->str .= 'Вы учавствуете.';
        }
    }

    public function __toString()
    {
        return $this->str;
    }
}
